#!/bin/bash
#
#   Print the TLS client ciphers send in TLS ClientHello
#
#   v0.1 Vesselin 25.05.2016
#
# Constants
echo "Client check ciphers v0.1 Vesselin"
echo
source ciphers.list

if [ $# -eq 0 ]; then
	echo "No arguments supplied. Please provide port number to lisen, for example 1432"
	exit 1
fi

echo "please start client to connect to port "$1
hex=`echo "test" | nc -l $1 -i 1| xxd -p| tr -d "\n"| tr '[:lower:]' '[:upper:]'`

# simple check if it look like SSL handshake
if [ "${hex:0:4}" = "1603" ]; then
	echo "SSL Handshake found"
else
	echo "Error: Not SSL Handshake found"
	exit 2
fi

version=${hex:18:4}
echo "TLS version("$version")   "${TlsVersion[$version]}

cipher_len="0x"${hex:88:4}

echo "cipher len: "$cipher_len
echo "---------------------------"
for (( i=92; i<$(($cipher_len*2+92)); i=i+4 ))
do 
	c=${hex:$i:4}
	echo  "cipher("$c")  "${Cipher[$c]}	
done
echo "---------------------------"


